VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Huffman"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'   2004
Option Explicit
Private Type HUFFMANTREE
  ParentNode As Integer
  RightNode As Integer
  LeftNode As Integer
  value As Integer
  Weight As Long
End Type

Private Type BytePoint
  Count As Long
  Point As Integer
End Type

'    ...
Dim ResetResult As Boolean
Dim BitValue(0 To 7) As Byte
Dim CharCount(0 To 255) As BytePoint
Dim Nodes(0 To 512) As HUFFMANTREE
Dim Result() As Byte
Dim LShiftCode() As Byte
Dim PLShiftCode As Long
Dim NodesCount As Integer

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal PLShiftCode As Long, ByVal value As Long, ByVal shift As Long, ByVal lp3 As Long, ByVal lp4 As Long) As Long
Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'    ...
Public Sub DynamicEncode(ByteArray() As Byte, ByteLen As Long)
  
  Dim BitPos As Byte
  Dim Count, lLength, i, j, ResultLen As Long
  Dim Char(0 To 511) As Byte
  Dim charLen As Integer

'     ...
  For i = 0 To 255
    CharCount(i).Count = 0
    CharCount(i).Point = 0
  Next
  
  ResetResult = True
  ReDim Result(0)

 
 NodesCount = 0
'   (  )...
 Nodes(0).LeftNode = -1
 Nodes(0).RightNode = -1
 Nodes(0).ParentNode = -1
 Nodes(0).value = 0
 Nodes(0).Weight = 0


'        ...
  For Count = 0 To 7
    BitValue(Count) = 2 ^ Count
  Next
  
'  ...
  1.T2 = " "
  1.T2.Refresh
  
  For i = 0 To UBound(ByteArray)

    If CharCount(ByteArray(i)).Count = 0 Then
'       ...
'      ,       ...
      FindInTree NodesCount, Char(), charLen
      SendResult Char(), charLen, Result(), False
'    ASCII   ...
      charLen = -1
      For j = 0 To 7
        If (ByteArray(i) And BitValue(j)) Then
          Char(charLen + 1) = 1
        Else
          Char(charLen + 1) = 0
        End If
        charLen = charLen + 1
      Next
      
'     ...
    AddNode ByteArray(i)
      
    Else
'       ...
      FindInTree CharCount(ByteArray(i)).Point, Char(), charLen
    End If
    SendResult Char(), charLen, Result(), False
    CharCount(ByteArray(i)).Count = CharCount(ByteArray(i)).Count + 1
    
'   ...
    BuildTree CharCount(), ByteArray(i)
  
  Next
  
  SendResult Char(), charLen, Result(), True
'     ByteArray    ...

'   ...
ResultLen = UBound(Result)
ReDim Preserve Result(UBound(Result) + 8)
Call CopyMem(Result(8), Result(0), ResultLen)
   Result(0) = 72
   Result(1) = 69
   Result(2) = 52
   Result(3) = 13
Call CopyMem(Result(4), ByteLen, 4)
  
  ResultLen = UBound(Result)
  If ResultLen <> 0 Then ReDim ByteArray(ResultLen - 1)
  Call CopyMem(ByteArray(0), Result(0), ResultLen)
  
End Sub

'     Result   ...
'   x -       ...
Private Static Sub SendResult(MArray() As Byte, charLen As Integer, Result() As Byte, x As Boolean)
  Dim ResultLen As Long
  Dim BitPos, Char As Byte
  Dim i As Long
  Dim j, xvx As Integer
  
'   ,    ...
  If ResetResult = True Then
    ResultLen = 0
    BitPos = 0
    Char = 0
    ResetResult = False
  End If
  
 '      - ,     (  "")...
  If x = True And BitPos > 0 Then
    Result(ResultLen) = Char
  Else
  xvx = (charLen + 1) - IIf(BitPos = 0, 0, 8 - BitPos)
  If xvx < 0 Then xvx = 0
  
'       - ...
  ReDim Preserve Result(UBound(Result) + IIf(xvx Mod 8 = 0, xvx \ 8, xvx \ 8 + 1))
  For j = charLen To 0 Step -1
    If (MArray(j) = 1) Then Char = Char + BitValue(BitPos)
    BitPos = BitPos + 1
    If (BitPos = 8) Then
      Result(ResultLen) = Char
      ResultLen = ResultLen + 1
      BitPos = 0
      Char = 0
    End If
  Next
End If

End Sub

'   ...
Public Sub DynamicDecode(ByteArray() As Byte)

  Dim Char As Byte
  Dim BitPos, Answer As Integer
  Dim BytePos As Long
  Dim j As Long
  Dim i As Long
  Dim ByteLen As Long
  Dim Count, ResultLen As Long
  
 NodesCount = 0
'   (  )...
 Nodes(0).LeftNode = -1
 Nodes(0).RightNode = -1
 Nodes(0).ParentNode = -1
 Nodes(0).value = 0
 Nodes(0).Weight = 0

'        ...
  For Count = 0 To 7
    BitValue(Count) = 2 ^ Count
  Next

'  ...
  If (ByteArray(0) <> 72) Or (ByteArray(1) <> 69) Or (ByteArray(3) <> 13) Then
    MsgBox " ...     ...", vbInformation
    Exit Sub
  End If

'    -   ...
Call CopyMem(ResultLen, ByteArray(4), 4)
ReDim Result(ResultLen) As Byte

'     ...
  For i = 0 To 255
    CharCount(i).Count = 0
  Next
  Count = 0
  BytePos = 8
  BitPos = 0

a:  i = IIf(NodesCount = 2, 1, 0)
c:  Answer = GetNextBit(ByteArray(), BytePos, BitPos)
  BitPos = BitPos + 1
  If BitPos = 8 Then
    BitPos = 0
    BytePos = BytePos + 1
  End If
'      ...
b:
'        ...
  If Nodes(i).value > -1 Then
'       ,   8  -  ...
    If Nodes(i).value = 0 And Nodes(i).Weight = 0 Then
      Char = 0
      For j = 7 To 0 Step -1
        Answer = GetNextBit(ByteArray(), BytePos, BitPos)
        If Answer = 1 Then Char = Char + BitValue(j)
        BitPos = BitPos + 1
        If BitPos = 8 Then
          BitPos = 0
          BytePos = BytePos + 1
       End If
      Next
'    ...
      CharCount(Char).Count = 1
      If Count >= ResultLen Then GoTo use
      Result(Count) = Char
      
'     ...
      AddNode Char
    Else
'   ...
      Char = Nodes(i).value
      CharCount(Char).Count = CharCount(Char).Count + 1
      If Count >= ResultLen Then GoTo use
      Result(Count) = Char
    End If
    Count = Count + 1
    BuildTree CharCount(), Char
    
    GoTo a
  Else
'   ,     ,   ...
    If Answer = 0 Then
      i = Nodes(i).RightNode
    Else
      i = Nodes(i).LeftNode
    End If
'     -    ,    ,  ,    ...
    If (Nodes(i).value = -1) Then GoTo c Else GoTo b
  End If

use:
  ReDim ByteArray(ResultLen - 1)
  Call CopyMem(ByteArray(0), Result(0), ResultLen)
  
End Sub

'      ...
Private Function GetNextBit(ByRef ByteArray() As Byte, ByVal IByte As Long, ByVal IPos As Integer) As Integer
Dim Char As Byte

  Char = ByteArray(IByte)
  If (Char And BitValue(IPos)) Then
    GetNextBit = 1
  Else
    GetNextBit = 0
  End If
End Function

'       ...
Public Function FileExist(FileName) As Boolean
  On Error GoTo Alas
  FileLen (FileName)
  FileExist = True
  Exit Function
Alas:
  FileExist = False
End Function

'       ...

'    Nodes(NodesCount + 1).LeftNode = NodesCount
'    Nodes(NodesCount + 1).RightNode = NodesCount + 2
'    Nodes(NodesCount + 1).ParentNode = Nodes(NodesCount).ParentNode
'    Nodes(NodesCount + 1).value = -1
'    Nodes(NodesCount + 1).Weight = 0
'
'    Nodes(NodesCount + 2).LeftNode = -1
'    Nodes(NodesCount + 2).RightNode = -1
'    Nodes(NodesCount + 2).ParentNode = NodesCount + 1
'    Nodes(NodesCount + 2).value = ByteArray(i)
'    Nodes(NodesCount + 2).Weight = 0
'
'    If Nodes(NodesCount).ParentNode <> -1 Then Nodes(Nodes(NodesCount).ParentNode).RightNode = NodesCount + 1
'    Nodes(NodesCount).ParentNode = NodesCount + 1
'    NodesCount = NodesCount + 2
'    CharCount(ByteArray(i)).Point = NodesCount

Private Sub AddNode(ByVal Char As Byte)
 Dim Char_ As Byte
 
 Char_ = Char
 
  LShiftCode = LoadResData("ADDNODE", "SUB")
  PLShiftCode = VarPtr(LShiftCode(0))
   
  CallWindowProc PLShiftCode, VarPtr(Nodes(0).ParentNode), VarPtr(NodesCount), VarPtr(Char_), VarPtr(CharCount(0).Count)

End Sub

'       ...

'  OutLen = 0
'  While Nodes(InByte).ParentNode <> -1
'    If Nodes(Nodes(InByte).ParentNode).LeftNode = InByte Then
'      MArray(OutLen) = 1
'    Else
'      MArray(OutLen) = 0
'    End If
'    OutLen = OutLen + 1
'    InByte = Nodes(InByte).ParentNode
'  Wend
'  OutLen = IIf(OutLen = 0, 0, OutLen - 1)

Private Sub FindInTree(ByVal InByte As Integer, MArray() As Byte, OutLen As Integer)
 
  Dim InByte_ As Integer
  
  InByte_ = InByte
  LShiftCode = LoadResData("FINDINTREE", "SUB")
  PLShiftCode = VarPtr(LShiftCode(0))
   
  CallWindowProc PLShiftCode, VarPtr(InByte_), VarPtr(MArray(0)), VarPtr(OutLen), VarPtr(Nodes(0).ParentNode)

End Sub

'     ...

'  Dim CurNode As Integer
'  Dim i As Integer
'
'  CurNode = CharCount(Char).Point
'  Do While True
'    Nodes(CurNode).Weight = Nodes(CurNode).Weight + 1
'    i = CurNode - 1
'    Do While i >= 0
'      If Nodes(i).Weight >= Nodes(CurNode).Weight Then Exit Do
'      i = i - 1
'    Loop
'    i = i + 1
'    If i < CurNode Then
'      swap Nodes(CurNode).LeftNode, Nodes(i).LeftNode
'      swap Nodes(CurNode).RightNode, Nodes(i).RightNode
'      swap Nodes(CurNode).value, Nodes(i).value
'      swap Nodes(CurNode).Weight, Nodes(i).Weight
'      If Nodes(CurNode).value <> -1 And Nodes(CurNode).Weight <> 0 Then CharCount(Nodes(CurNode).value).Point = CurNode
'      If Nodes(i).value <> -1 And Nodes(i).Weight <> 0 Then CharCount(Nodes(i).value).Point = i
'
'      If Nodes(i).LeftNode = i Or Nodes(i).RightNode = i Then
'        Nodes(i).ParentNode = Nodes(CurNode).ParentNode
'        Nodes(CurNode).ParentNode = i
'        If Nodes(i).LeftNode = i Then
'          Nodes(i).LeftNode = CurNode
'        Else
'          Nodes(i).RightNode = CurNode
'        End If
'        If Nodes(i).ParentNode <> -1 Then
'          If Nodes(Nodes(i).ParentNode).LeftNode = CurNode Then
'            Nodes(Nodes(i).ParentNode).LeftNode = i
'          Else
'            Nodes(Nodes(i).ParentNode).RightNode = i
'          End If
'        End If
'      End If
'
'      If Nodes(i).value = -1 Then
'        Nodes(Nodes(i).LeftNode).ParentNode = i
'        Nodes(Nodes(i).RightNode).ParentNode = i
'      End If
'      If Nodes(CurNode).value = -1 Then
'        Nodes(Nodes(CurNode).LeftNode).ParentNode = CurNode
'        Nodes(Nodes(CurNode).RightNode).ParentNode = CurNode
'      End If
'      CurNode = i
'    End If
'    CurNode = Nodes(CurNode).ParentNode
'    If CurNode = -1 Then Exit Do
'  Loop

Private Sub BuildTree(ByRef CharCount() As BytePoint, Char As Byte)

Dim CharN As Byte

CharN = Char
 LShiftCode = LoadResData("BUILDTREE", "SUB")
  PLShiftCode = VarPtr(LShiftCode(0))
   
  CallWindowProc PLShiftCode, VarPtr(CharCount(0).Count), VarPtr(Nodes(0).ParentNode), VarPtr(CharN), 0&

End Sub
